"""
#################################################################
#                                                               #
# Propably the easiest and most complex Say Sounds addon :)     #
# scripted by OMG Noob                                          #
#                                                               #
#   Many thanks to:                                             #
#       Nato_Hunter                                             #
#       GODJonez                                                #
#                                                               #
#   Go to the config.cfg and                                    #
#   customise the configs to your request                       #
#                                                               #
# Don't change anything in here!                                #
#################################################################
"""

import es
import popuplib
import langlib
import keyvalues
import playerlib
import random
import settinglib
import os.path

info = es.AddonInfo()
info.name     = "OMG Noob's easy Say Sounds"
info.version  = "1.0"
info.url      = "http://addons.eventscripts.com/addons/view/saysounds"
info.basename = "Say Sounds"
info.author   = "OMG Noob"

say_sounds			= es.ServerVar("say_sounds",				1, "Enable/disable Say Sounds")
say_sounds_announce		= es.ServerVar("say_sounds_announce",			1, "Announces Say Sounds each round.")
say_sounds_create_soundlist	= es.ServerVar("say_sounds_create_soundlist",		2, "1 if you want to load the textfile db as the soundlist. 2 if you want to load the soundlist from the folder structure")
say_sounds_folder		= es.ServerVar("say_sounds_folder",		'say_sounds', "You use this folder, if you load the soundlist from the folder structure")
say_sounds_autodownload		= es.ServerVar("say_sounds_autodownload",		1, "Should the sounds be auto-downloaded with EventScripts?")
say_sounds_limit		= es.ServerVar("say_sounds_limit",			2, "How much sounds can normal (non-admin) players play each round?")
say_sounds_default		= es.ServerVar("say_sounds_default",			1, "Default setting for new players? Say sounds ON/OFF")
say_sounds_savetime		= es.ServerVar("say_sounds_savetime",			30, "How much days should inactive users be stored, before their settings get deleted? ( default = 30 )")
say_sounds_stopoldsound		= es.ServerVar("say_sounds_stopoldsound",		1, "Should the 'old' sound be stopped before the 'new' one begins? This prevents that many sounds are played at the same time.")

text = None
say_sounds_admins = None
oldsound = None
say_sounds_settings = None
adminlist = None
soundlist = None
say_sounds_temp = None
say_sounds_user_settings = None
say_sounds_command_list = None
 
def load():
	global text, say_sounds_admins, say_sounds_settings, adminlist, soundlist, say_sounds_temp, say_sounds_user_settings, say_sounds_command_list, say_sounds_savetime, round_counter
	es.ForceServerCommand("es_mexec ../addons/eventscripts/easy_say_sounds/config.cfg")
	if say_sounds > 0:
		round_counter = 0
		if not settinglib.exists('say_sounds_user_settings'): 
			say_sounds_user_settings = settinglib.create("say_sounds_user_settings", "User Settings", "toggle")
			say_sounds_user_settings.addoption('sound_setting','User Setting')
			say_sounds_user_settings.setdefault('sound_setting',say_sounds_default)
		else:
			say_sounds_user_settings = settinglib.find('say_sounds_user_settings')
		say_sounds_savetime = int(say_sounds_savetime)*86400
		say_sounds_user_settings.clear(say_sounds_savetime)
		adminlist = []
		soundlist = []
		say_sounds_command_list = []
		say_sounds_temp = {}
		if say_sounds_create_soundlist == '2':
			say_sounds_settings = create_soundlist_from_path()
		else:
			say_sounds_settings = create_soundlist_from_textfile()
		text = langlib.Strings(es.getAddonPath("easy_say_sounds") + "/strings.ini")
		say_sounds_create_menus_for_admins()
		say_sounds_create_menus_for_nonadmins()
		if es.exists('keygroup','easy_say_sounds_admins'):
			es.keygroupdelete('easy_say_sounds_admins')
		es.keygroupload('easy_say_sounds_admins', '|easy_say_sounds')
		say_sounds_admins = keyvalues.getKeyGroup('easy_say_sounds_admins')
		if say_sounds_autodownload > 0:
			for sound in soundlist:
				es.stringtable('downloadables', 'sound/' + sound)
		
def create_soundlist_from_path():
	if es.exists('keygroup','say_sounds_settings'):
		es.keygroupdelete('say_sounds_settings')
	es.keygroupcreate("say_sounds_settings")
	say_sounds_settings = keyvalues.getKeyGroup("say_sounds_settings")	
	directory = 'cstrike/sound/'+say_sounds_folder+'/'
	join = os.path.join
	for f in os.listdir(directory):
		pathname = join(directory, f)
		if os.path.isdir(pathname):
			say_sounds_settings[unicode(f, 'latin-1').encode('utf8')] = keyvalues.KeyValues(name=unicode(f, 'latin-1').encode('utf8'))
			for sounds in os.listdir(pathname):
				soundpathname = join(pathname, sounds)
				zaehler = 0
				if os.path.isdir(soundpathname):
					say_sounds_settings[unicode(f, 'latin-1').encode('utf8')][unicode(sounds, 'latin-1').encode('utf8')] = keyvalues.KeyValues(name=unicode(sounds, 'latin-1').encode('utf8'))
					for zufallssound in os.listdir(soundpathname):
						zufallssoundpathname = join(soundpathname, zufallssound)
						if os.path.isfile(zufallssoundpathname):
							if os.path.splitext(zufallssound)[1] == '.wav' or os.path.splitext(zufallssound)[1] == '.mp3':
								soundpath = pathname+'/'+sounds+'/'+zufallssound
								soundpath = soundpath.replace('cstrike/sound/','')
								say_sounds_settings[unicode(f, 'latin-1').encode('utf8')][unicode(sounds, 'latin-1').encode('utf8')][str(zaehler)] = soundpath
								zaehler += 1
				elif os.path.isfile(soundpathname):
					if os.path.splitext(sounds)[1] == '.wav' or os.path.splitext(sounds)[1] == '.mp3':
						command = os.path.splitext(sounds)[0]
						soundpath = pathname+'/'+sounds
						soundpath = soundpath.replace('cstrike/sound/','')
						say_sounds_settings[unicode(f, 'latin-1').encode('utf8')][unicode(command, 'latin-1').encode('utf8')] = soundpath
	return say_sounds_settings
						
def create_soundlist_from_textfile():
	if es.exists('keygroup','say_sounds_settings'):
		es.keygroupdelete('say_sounds_settings')
	es.keygroupcreate("say_sounds_settings")
	say_sounds_settings = keyvalues.getKeyGroup("say_sounds_settings")
	if es.exists('keygroup','easy_say_sounds_settings_file'):
		es.keygroupdelete('easy_say_sounds_settings_file')
	es.keygroupload('easy_say_sounds_settings_file', '|easy_say_sounds')
	say_sounds_soundlist = keyvalues.getKeyGroup("easy_say_sounds_settings_file")
	for category in say_sounds_soundlist:
		say_sounds_settings[unicode(category.getName(), 'latin-1').encode('utf8')] = keyvalues.KeyValues(name=unicode(category.getName(), 'latin-1').encode('utf8'))
		soundlist_textfile = []
		repeated_commands_textfile = []
		for sounds in category:
			if not sounds.getName() in soundlist_textfile:
				soundlist_textfile.append(sounds.getName())
			else:
				repeated_commands_textfile.append(sounds.getName())
		for commands in repeated_commands_textfile:
			say_sounds_settings[unicode(category.getName(), 'latin-1').encode('utf8')][unicode(commands, 'latin-1').encode('utf8')] = keyvalues.KeyValues(name=unicode(commands, 'latin-1').encode('utf8'))
		zaehler = 0
		for sounds in category:
			if not sounds.getName() in repeated_commands_textfile:
				say_sounds_settings[unicode(category.getName(), 'latin-1').encode('utf8')][unicode(sounds.getName(), 'latin-1').encode('utf8')] = sounds.getString()
			else:
				say_sounds_settings[unicode(category.getName(), 'latin-1').encode('utf8')][unicode(sounds.getName(), 'latin-1').encode('utf8')][str(zaehler)] = sounds.getString()
				zaehler += 1
	return say_sounds_settings
					
def say_sounds_create_menus_for_admins():
	global soundcategorymenu_admin, soundlistmenu
	if popuplib.exists('soundcategorymenu_admin'):
		popuplib.delete('soundcategorymenu_admin')
	soundcategorymenu_admin = popuplib.easymenu('soundcategorymenu_admin', '_popup_choice', category_menuselect) 
	for category in say_sounds_settings:
		soundcategorymenu_admin.addoption(category.getName(), category.getName())
		if popuplib.exists(category.getName()+'menu'):
			popuplib.delete(category.getName()+'menu')
		soundlistmenu = popuplib.easymenu(category.getName()+'menu', '_popup_choice', write_sound_in_chat)
		for sound in category:
			soundlistmenu.addoption(sound.getName(), sound.getName())
			if not sound.getName() in say_sounds_command_list:
				say_sounds_command_list.append(sound.getName())
			for zufallssound in sound:
				soundlist.append(zufallssound.getString())
			else:
				if sound.getString() != '':
					soundlist.append(sound.getString())

def say_sounds_create_menus_for_nonadmins():
	global soundcategorymenu
	if popuplib.exists('soundcategorymenu'):
		popuplib.delete('soundcategorymenu')
	soundcategorymenu = popuplib.easymenu('soundcategorymenu', '_popup_choice', category_menuselect) 
	for category in say_sounds_settings:
		if category.getName() != 'Adminsounds':
			soundcategorymenu.addoption(category.getName(), category.getName())
				
def round_start(event_var):
	global round_counter
	say_sounds_temp = {}
	if say_sounds > 0 and say_sounds_announce > 0:
		round_counter += 1
		if (round_counter % say_sounds_announce) == 0:
			player_list = playerlib.getPlayerList('#human')
			for player in player_list:
				es.tell(player.userid, "#multi",unicode(text('announcement',None,player.get("lang")), 'latin-1').encode('utf8'))
				es.tell(player.userid, "#multi",unicode(text('sounds_on_off_announcement',None,player.get("lang")), 'latin-1').encode('utf8'))
		
def player_say(event_var):
	if say_sounds > 0:
		say_player = playerlib.getPlayer(event_var['userid'])
		if event_var['text'] == 'soundlist':
			soundlistmenu.settitle(unicode(text('soundlist_menu_header',None,say_player.get("lang")), 'latin-1').encode('utf8'))
			if event_var['userid'] in adminlist:
				soundcategorymenu_admin.settitle(unicode(text('category_menu_header',None,say_player.get("lang")), 'latin-1').encode('utf8'))
				popuplib.send('soundcategorymenu_admin', int(event_var['userid']))
			else:
				soundcategorymenu.settitle(unicode(text('category_menu_header',None,say_player.get("lang")), 'latin-1').encode('utf8'))
				popuplib.send('soundcategorymenu', int(event_var['userid']))
		elif event_var['text'] == 'sounds':
			user_setting = say_sounds_user_settings.get('sound_setting',event_var['userid'])
			if user_setting:
				say_sounds_user_settings.set('sound_setting',0,event_var['userid'])
				es.stopsound(event_var['userid'],oldsound)
				es.tell(event_var['userid'], '#multi', unicode(text('sounds_off',None,say_player.get("lang")), 'latin-1').encode('utf8'))
			else:
				say_sounds_user_settings.set('sound_setting',1,event_var['userid'])
				es.tell(event_var['userid'], '#multi', unicode(text('sounds_on',None,say_player.get("lang")), 'latin-1').encode('utf8'))
		elif event_var['text'] in say_sounds_command_list:
			play_sound(event_var['userid'],event_var['text'])

def category_menuselect (userid, choice, popupid):
	popuplib.send(choice+'menu', userid)

def write_sound_in_chat (userid, choice, popupid):
	es.sexec(userid, 'say '+choice)

def play_sound (userid,sound):
	global oldsound 
	name = es.getplayername(userid)
	sound_player = playerlib.getPlayer(userid)
	tokens = {}
	tokens['name'] = name
	tokens['sound'] = sound
	soundfiles = []
	sound_category = None
	for category in say_sounds_settings:
		for sounds in category:
			if sound == sounds.getName():
				for zufallssound in sounds:
					soundfiles.append(zufallssound.getString())
				else:
					if sounds.getString() != '':	
						soundfiles.append(sounds.getString())
				sound_category = category.getName()
	if sound_category != None:
		soundfile = random.choice(soundfiles)
		player_list = playerlib.getPlayerList('#human')
		if sound_category == 'Adminsounds':
			if str(userid) in adminlist:
				for player in player_list:
					if say_sounds_stopoldsound > 0:
						es.stopsound(int(player),oldsound)
					if say_sounds_user_settings.get('sound_setting',player):
						es.playsound(int(player), soundfile, '1.0')
				es.msg("#multi", unicode(text('admin_played_sound',tokens,sound_player.get("lang")), 'latin-1').encode('utf8'))
				oldsound = soundfile		
		else:
			if str(userid) in adminlist:
				for player in player_list:
					if say_sounds_stopoldsound > 0:
						es.stopsound(int(player),oldsound)
					if say_sounds_user_settings.get('sound_setting',player):
						es.playsound(int(player), soundfile, '1.0')
				es.msg("#multi", unicode(text('admin_played_sound',tokens,sound_player.get("lang")), 'latin-1').encode('utf8'))
				oldsound = soundfile
			else:
				if not say_sounds_temp.has_key(userid):
					say_sounds_temp[userid] = 0
				if say_sounds_temp[userid] < say_sounds_limit:
					for player in player_list:
						if say_sounds_stopoldsound > 0:
							es.stopsound(int(player),oldsound)
						if say_sounds_user_settings.get('sound_setting',player):
							es.playsound(int(player), soundfile, '1.0')
					es.msg("#multi", unicode(text('nonadmin_played_sound',tokens,sound_player.get("lang")), 'latin-1').encode('utf8'))
					oldsound = soundfile
					say_sounds_temp[userid] +=1
				else:
					es.tell(userid, "#multi", unicode(text('reached_soundlimit',None,sound_player.get("lang")), 'latin-1').encode('utf8'))

def player_connect(event_var):
	adresse = event_var['address']
	ip_port_array = adresse.split(':')
	ips = say_sounds_admins['ip']
	for ipadresse in ips:
		es.dbgmsg(0, 'adminip: '+ipadresse.getName())
		es.dbgmsg(0, 'userip: '+ip_port_array[0])
		if ipadresse.getName() == ip_port_array[0]:
			update_admin_list(event_var['userid'])
			
def player_activate(event_var):
	es.queryclientvar(event_var['userid'], '_password')
	steamids = say_sounds_admins['steamid']
	for steamid in steamids:
		if steamids.getName() == event_var['es_steamid']:
			update_admin_list(event_var['userid'])

def es_player_variable(event_var):
	if event_var['status'] == 'success':
		if event_var['variable'] == '_password':
			names = say_sounds_admins['name']
			for name in names:
				if name.getName() == event_var['es_username']:
					if name.getString() == str(event_var['value']):
						update_admin_list(event_var['userid'])
		
def update_admin_list(userid):
	if not str(userid) in adminlist:
		adminlist.append(str(userid))

def player_disconnect(event_var):
	if event_var['userid'] in adminlist:
		adminlist.remove(event_var['userid'])			

def es_map_start(event_var):
	global round_counter
	round_counter = 0
	if say_sounds > 0 and say_sounds_autodownload > 0:
		for sound in soundlist:
			es.stringtable('downloadables', 'sound/' + sound)
	
	


